// BSLLS:FunctionShouldHaveReturn-off

// Возвращает итератор коллекции
//
//  Возвращаемое значение:
//   Итератор - Итератор коллекции
//
Функция Итератор() Экспорт
КонецФункции

// Выполняет переданный алгоритм для каждого элемента коллекции
//
// Параметры:
//   Алгоритм - Действие - Делегат на процедуру с одним параметром, в который
//    будет передан элемент коллекции
//            - Строка - Лямбда выражение с одним параметром, в который будет
//    будет передан элемент коллекции
//   Контекст - Структура - Контекст добавляемый в лямбда выражение, значения будут доступны по обращению
//    к ключу как к переменной.
//    При передачи действия в первом параметре, этот параметр игнорируется
//            - Сценарий - Экземпляр объекта, который будет захвачен в лямбда выражение, в лямбда выражении
//    будет доступен контекст (публичные и приватные поля, публичные методы) объекта.
//    При передачи действия в первом параметре, этот параметр игнорируется
//
// Пример:
//    Обходимое.ДляКаждого("Элемент -> Сообщить(Элемент)");
//
//    Обходимое.ДляКаждого("Элемент -> Массив.Добавить(Элемент)", Новый Структура("Массив", Новый Массив));
//
Процедура ДляКаждого(Алгоритм, Контекст) Экспорт
КонецПроцедуры

&Интерфейс
Процедура ПриСозданииОбъекта()
	ВызватьИсключение "Нельзя создать экземпляр интерфейса";
КонецПроцедуры
