// BSLLS:FunctionShouldHaveReturn-off

// Проверяет что есть следующий элемент коллекции
//
//  Возвращаемое значение:
//   Булево - Истина, если есть следующий элемент коллекции
//
Функция ЕстьСледующий() Экспорт
КонецФункции

// Возвращает следующий элемент коллекции
//
//  Возвращаемое значение:
//   Произвольный - следующий элемент коллекции
//
Функция Следующий() Экспорт
КонецФункции

// Выполняет переданный алгоритм для каждого элемента коллекции
//  начиная с того на который указывает итератор
//
// Параметры:
//   Действие - Действие - Делегат на процедуру с одним параметром
//    которая принимает элемент коллекции
//            - Строка - Лямбда выражение с одним параметром
//    которая принимает элемент коллекции
//   Контекст - Структура - Контекст добавляемый в лямбда выражение, значения будут доступны по обращению
//    к ключу как к переменной.
//    При передачи действия в первом параметре, этот параметр игнорируется
//            - Сценарий - Экземпляр объекта, который будет захвачен в лямбда выражение, в лямбда выражении
//    будет доступен контекст (публичные и приватные поля, публичные методы) объекта.
//    При передачи действия в первом параметре, этот параметр игнорируется
//
// Пример:
//    Итератор.ДляКаждогоОставшегося("Элемент -> Сообщить(Элемент)");
//
//    Итератор.ДляКаждогоОставшегося("Элемент -> Массив.Добавить(Элемент)", Новый Структура("Массив", Новый Массив));
//
Процедура ДляКаждогоОставшегося(Действие, Контекст) Экспорт
КонецПроцедуры

&Интерфейс
Процедура ПриСозданииОбъекта()
	ВызватьИсключение "Нельзя создать экземпляр интерфейса";
КонецПроцедуры
