#Использовать "../../../internal"

Перем ВнутреннееМножество;  // Оригинальная коллекция
Перем Блокировка;           // Блокировка для синхронизации доступа

Функция Итератор() Экспорт
	Возврат ВнутреннееМножество.Итератор();
КонецФункции

Процедура ДляКаждого(Алгоритм, Контекст = Неопределено) Экспорт
	
	Блокировка.Заблокировать();

	Попытка
		ВнутреннееМножество.ДляКаждого(Алгоритм, Контекст);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение;
	КонецПопытки;

	Блокировка.Разблокировать();

КонецПроцедуры

Функция Содержит(Элемент) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннееМножество.Содержит(Элемент);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение;
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция СодержитВсе(Коллекция) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннееМножество.СодержитВсе(Коллекция);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение;
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция Пусто() Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннееМножество.Пусто();
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение;
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;
	
КонецФункции

Функция ПроцессорКоллекции() Экспорт
	Возврат ВнутреннееМножество.ПроцессорКоллекции();
КонецФункции

Функция Количество() Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннееМножество.Количество();
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение;
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция ВМассив() Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннееМножество.ВМассив();
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение;
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция Добавить(Элемент) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннееМножество.Добавить(Элемент);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение;
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция ДобавитьВсе(Коллекция) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннееМножество.ДобавитьВсе(Коллекция);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение;
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Процедура Очистить() Экспорт

	Блокировка.Заблокировать();

	Попытка
		ВнутреннееМножество.Очистить();
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение;
	КонецПопытки;

	Блокировка.Разблокировать();

КонецПроцедуры

Функция Удалить(Элемент) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннееМножество.Удалить(Элемент);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение;
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция УдалитьВсе(Коллекция) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннееМножество.УдалитьВсе(Коллекция);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение;
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция УдалитьЕсли(Предикат, Контекст = Неопределено) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннееМножество.УдалитьЕсли(Предикат, Контекст);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение;
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция СохранитьВсе(Коллекция) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннееМножество.СохранитьВсе(Коллекция);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение;
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Процедура ОбработкаПолученияПредставления(Представление, СтандартнаяОбработка) // BSLLS:UnusedLocalMethod-off
	КоллекцииСлужебный.ОбработчикПолученияПредставленияКоллекции(ЭтотОбъект, Представление, СтандартнаяОбработка);
КонецПроцедуры

Функция ПолучитьИтератор() // BSLLS:UnusedLocalMethod-off
	Возврат Новый СлужебныйИтераторДляДвижка(Итератор());
КонецФункции

&Обходимое
&Реализует("Множество")
Процедура ПриСозданииОбъекта(Множество)
	
	ВнутреннееМножество  = Множество;
	Блокировка           = Новый БлокировкаРесурса(ЭтотОбъект);

КонецПроцедуры
